SystemOrganization addCategory: #'EjerciciosPoo-OnlineSale'!

Object subclass: #Cart
	instanceVariableNames: 'productsContained productCatalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 19:38'!
newWith: aCatalog

	^self new initializeinitializeWith: aCatalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:26'!
add: aNewProduct quantity: aQuantityOfProduct 
	(aQuantityOfProduct > 0) 
		ifFalse: [self error: 'Cannot add a negative or zero quantity'.].

	(productCatalog includesKey: aNewProduct) 
		ifFalse: [self error: 'The product does not belong to the editorial'.].
		
	productsContained add: aNewProduct withOccurrences: aQuantityOfProduct.
			
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:51'!
contains: aProduct 
	^ productsContained includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 19:37'!
initializeinitializeWith: aCatalog
	productsContained:= Bag new.
	productCatalog:= aCatalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 19:44'!
isEmpty 
	^productsContained isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:12'!
quantityOf: aProduct
	^productsContained occurrencesOf: aProduct.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:17'!
saleAmount
| anAmount |

	anAmount:=0.
	productsContained do: [ :aSaleItem |  anAmount:= anAmount + (productCatalog at: aSaleItem) ].
	^anAmount.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 20:56'!
size
	^ productsContained size.! !

Object subclass: #Cashier
	instanceVariableNames: 'merchanceProcessorInterface bookSale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:33'!
newWith: aMerchanceProcessorInterface and: aBookSale
	^self new initializeWith: aMerchanceProcessorInterface and: aBookSale

! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:55'!
checkOut: aCart withCreditCard: aCreditCard
| anAmount |
	(aCart isEmpty ) 
		ifTrue: [self error: 'The cart to be checked out can not be empty'.].

	(aCreditCard isExpiredOn: (MonthOfYear onMonthNumber: ((Date today) monthIndex)  of: ((Date today) year)))
	ifTrue: [self error: 'The credit card is expired'.]. 
	
	anAmount:= aCart saleAmount.
	 [ merchanceProcessorInterface debitFrom: aCreditCard amount: anAmount] on: Error do: [ :anError | anAmount:=0. self  error: anError  ].
	bookSale add: (Sale to: (aCreditCard name) saled: aCart totalAmount: anAmount).
	^anAmount.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:33'!
initializeWith: aMerchanceProcessorInterface and: aBookSale
	merchanceProcessorInterface :=  aMerchanceProcessorInterface.
	bookSale := aBookSale.! !

Object subclass: #MerchanceProcessorInterface
	instanceVariableNames: 'aMerchanceProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!MerchanceProcessorInterface methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:43'!
debitFrom: aCreditCard amount: anAmount
"	aMerchanceProcessor debitFrom: aCreditCard amount: anAmount"! !

MerchanceProcessorInterface subclass: #MerchanceProcessorInterfaceStub
	instanceVariableNames: 'used debitResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!MerchanceProcessorInterfaceStub class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:44'!
newWith: aBlockOnDebit
	^self new initializeWith:  aBlockOnDebit
! !

!MerchanceProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:54'!
debitFrom: aCreditCard amount: anAmount
| theResponse |
	used := true.
	theResponse:=debitResponse value: aCreditCard value: anAmount.
	(theResponse beginsWith:  '1' ) ifTrue: [ self error: theResponse].
	^theResponse.! !

!MerchanceProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:48'!
initializeWith:  aBlockOnDebit
	used := false.
	debitResponse := aBlockOnDebit.! !

!MerchanceProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:42'!
used
	^used.! !

Object subclass: #Sale
	instanceVariableNames: 'nameOfBuyer saledItems amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:14'!
to: aName saled: aCart totalAmount: aSmallInteger 
	^self new initializeWith: aName saled: aCart totalAmount: aSmallInteger .! !

!Sale methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:16'!
initializeWith: aName saled: aCart totalAmount: anAmount 
	nameOfBuyer:= aName.
	saledItems:= aCart.
	amount:= anAmount.! !

TestCase subclass: #OnlineSaleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!OnlineSaleTest methodsFor: 'accessing' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:37'!
aBookSale
	^OrderedCollection new.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 20:58'!
aCart: aCatalog
	^Cart newWith: aCatalog.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/14/2012 19:35'!
aCashier
	^Cashier new.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:06'!
aExpirationDate
	
	^MonthOfYear onMonthNumber: ((Date today) monthIndex)  of: ((Date today) year-1). 
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/14/2012 20:05'!
aExpiriedCreditCard
	^CreditCard ownedBy: 'Pepe'  identifiedBy:  '123456789' expiresOn: self aExpirationDate. ! !

!OnlineSaleTest methodsFor: 'accessing' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:29'!
aMerchanceProcessorInterface: responseBlock
	^MerchanceProcessorInterfaceStub newWith: responseBlock! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aProduct
	^ '1'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aSecondProduct
	^ '2'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aThirdProduct
	^ '3'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:41'!
aValidCreditCard
	^CreditCard ownedBy: 'Pepe'  identifiedBy:  '123456789' expiresOn: self validExpirationDate. ! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:20'!
catalog
	^Dictionary  new.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:09'!
test01NewCartCannotContainsProducts

	self assert: ((self aCart: (self catalog)) isEmpty ).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test02GivenACartWhenAddAProductThenTheCartContainThis

	| aCart aCatalog aProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	
	self assert: (aCart contains: aProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:22'!
test03GivenACartWhenAddAProductThenTheCartNotContainAnotherProduct

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 1).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	
	self deny: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test04GivenACartWhenAddAProductThenTheCartContainsTheQuantityAddedOfThatProduct

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	self assert: (aCart size = 3).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test05GivenACartWhenAddAProductThatAlreadyExistsThenTheCartContainsTheSumOfTheQuantities

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 4.
	self assert: (aCart size = 7).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test06GivenACartWhenAddAProductThenTheQuantityShouldNotBeNegative

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: -1] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'Cannot add a negative or zero quantity').
		self assert: aCart isEmpty.
					
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test07GivenACartWhenAddAProductThenTheQuantityShouldNotBeZero

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: 0] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText='Cannot add a negative or zero quantity').
		self assert: aCart isEmpty.
					
		]


	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:24'!
test08GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsBothProducts

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:24'!
test09GivenACartWhenAddAProductAndAnotherProductThenTheCartCanReturnAListOfTheProductsWithItsQuantities

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:25'!
test10GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsTheCorrectedQuantityOfThem

	| aCart aCatalog aProduct aSecondProduct aThirdProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 10).

	aCart := self aCart: aCatalog.
	aThirdProduct := self aThirdProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 2.
	aCart add: aSecondProduct quantity: 1.

	self assert: ((aCart quantityOf: aProduct) = 5).	
	self assert: ((aCart quantityOf: aSecondProduct) = 1).
	self assert: ((aCart quantityOf: aThirdProduct) = 0).! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:20'!
test11GivenACartWhenAddAProductWhichIsNotInTheCatalogThenTrowNotIncludedInCatalogException

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: 1] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'The product does not belong to the editorial').
		self assert: aCart isEmpty.
					
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:34'!
test12AnEmptyCartCannotBeCheckedOut

	| aCart aCatalog  aCashier aCreditCard aMerchanceProcessorInterface aBookSale |
	
	aCatalog := self catalog.
	aCart := self aCart: aCatalog.
	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '0|OK']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.
	aCreditCard := self aValidCreditCard.
	self should: [ aCashier checkOut: aCart withCreditCard: aCreditCard ] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'The cart to be checked out can not be empty').
		self assert: (aCart isEmpty).
		self assert: (aBookSale isEmpty).
		self deny: (aMerchanceProcessorInterface used).
			]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:30'!
test13ACartCannotBeCheckedOutWithAnExpiriedCreditCard

	| aCart aCatalog  aCashier aCreditCard aProduct validDate aBookSale aMerchanceProcessorInterface |

	aProduct := self aProduct.
	aCatalog := self catalog.
	aCatalog add:  (Association key: aProduct value: 10).

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.

	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '0|OK']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.

	aCreditCard := self aExpiriedCreditCard.

	self should: [ aCashier checkOut: aCart withCreditCard: aCreditCard ] raise: Error withExceptionDo: [:anError |

		self assert: (anError messageText = 'The credit card is expired').
		self assert: (aCart contains: aProduct).
		self assert: (aBookSale isEmpty).
		self deny: (aMerchanceProcessorInterface used).
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:31'!
test14GivenToCheckOutAFullCartWithAValidCreditCardThenTheSaleWasSuccessfulyDone

	| aCart aCatalog  aCashier aCreditCard aProduct validDate aBookSale aMerchanceProcessorInterface anAmount |

	aProduct := self aProduct.
	aCatalog := self catalog.
	aCatalog add:  (Association key: aProduct value: 10).

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.

	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '0|OK']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.

	aCreditCard := self aValidCreditCard.
	anAmount := aCashier checkOut: aCart withCreditCard: aCreditCard.
	self assert: (anAmount = 30).
	self deny: (aBookSale isEmpty).
	self assert: (aMerchanceProcessorInterface used).

	

	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:55'!
test15GivenASaleWithAStolenCreditCardThenTheMerchanceProcessorGivesAnException

	| aCart aCatalog  aCashier aCreditCard aProduct validDate aBookSale aMerchanceProcessorInterface anAmount |

	aProduct := self aProduct.
	aCatalog := self catalog.
	aCatalog add:  (Association key: aProduct value: 10).

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.

	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '1|Stolen CreditCard']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.

	aCreditCard := self aValidCreditCard.
		
	self should: (anAmount := aCashier checkOut: aCart withCreditCard: aCreditCard) 
		raise: Error withExceptionDo: [:anError | 
		self assert: (anAmount =0).
		self assert: (anError  = '1|Stolen CreditCard').
		self assert: (aBookSale isEmpty).
		self assert: (aMerchanceProcessorInterface used).
		].

	

	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:06'!
validExpirationDate
		
		^MonthOfYear onMonthNumber: ((Date today) monthIndex)  of: ((Date today) year+1).! !
